; exemple d'utilisation de STFA

	include	'stfa_def.s'

Pterm0	macro
	clr.w	-(sp)
	trap	#1
	addq.l	#2,sp
	illegal
	endm

Cnecin	macro
	move.w	#8,-(sp)
	trap	#1
	addq.l	#2,sp
	endm
	
Cconws	macro
	pea	\1
	move.w	#9,-(sp)
	trap	#1
	addq.l	#6,sp
	endm


Supers	macro
	move.l	\1,-(sp)
	move.w	#32,-(sp)
	trap	#1
	addq.l	#6,sp
	endm

Mshrink	macro
	move.l	\2,-(sp)
	move.l	\1,-(sp)
	clr.w	-(sp)
	move.w	#74,-(sp)
	trap	#1
	lea	12(sp),sp
	endm
	
Init_prg	macro
; Init_prg #taille_pile
	move.l	4(sp),a6
	move.l	12(a6),a5
	add.l	20(a6),a5
	add.l	28(a6),a5
	add.l	#$100,a5
	add.l	\1,a5
	move.l	a5,d1
	and.w	#$fffe,d1
	add.l	a6,d1
	move.l	d1,sp
	Mshrink	a6,a5
	endm

main:
	Init_prg	#$500
	Supers	#0
	move.l	d0,ssp
	
search_cookie:
	move.l	$5a0.w,d0
	moveq	#-1,d1
	tst.l	d0
	beq.s	search_xbra	; pas de cookie jar
	move.l	d0,a0			
.search_it:
	move.l	(a0)+,d0
	beq.s	.end_search_it
	cmp.l	#'STFA',d0
	beq.s	.trouve
	addq.l	#4,a0
	bra.s	.search_it
.trouve:
	moveq	#0,d1
.end_search_it:
search_xbra:
	tst.l	d1
	beq.s	no_need
	move.l	$70.w,a0
.search_it:
	move.l	-12(a0),d0
	cmp.l	#'XBRA',d0
	bne.s	fin
	move.l	-8(a0),d0
	cmp.l	#'STFA',d0
	beq.s	.trouve
	move.l	-4(a0),a0
	bra.s	.search_it	
.trouve:
	lea	-16(a0),a0	; on se place sur le paramtre
	moveq	#0,d1
no_need:
	move.l	(a0),stfa_control
	move.l	(a0),a0
	move.w	#$8008,STFA_control.sound_control(a0)	; sign  16400 Hz en mono 8 bits
*	clr.w	4(a0)		; sur le Yamaha
*	move.w	#1,4(a0)	; ou sur la MV16
	move.l	#debut_son,STFA_control.sound_start(a0)
	move.l	#fin_son,STFA_control.sound_end(a0)
	move.l	#my_rout,STFA_control.it(a0)
	move.l	a0,-(sp)
	Cconws	key(pc)
	move.l	(sp)+,a0
	move.w	#%11,(a0)	; joue le son en boucle
	move.l	a0,-(sp)
*	Cnecin      		; attend une touche
.wait:
	tst.w	flag_it
	beq.s	.wait
	Cconws	freeware(pc)
	IFEQ	1
	tst.w	flag_it
	beq.s	.it_fail
.it_ok:
	Cconws	it_ok(pc)
	bra.s	.it_end
.it_fail:
	Cconws	it_fail(pc)
.it_end:
	ENDC
	Cnecin
	move.l	(sp)+,a0
	bclr.b	#0,1(a0)		; coupe le son
fin:
	Supers	ssp(pc)	
	Pterm0
ssp:
	dc.l	'Rmv!'
stfa_control:
	dc.l	'Seb!'
	
my_rout:
	movem.l	d0-d7/a0-a6,-(sp)
	move.w	#$ffff,flag_it
	movem.l	(sp)+,d0-d7/a0-a6
	rte
	
freeware:
	dc.b	27,'E'
	dc.b	'Ne vous inquitez pas, STFA est FREEWARE',13,11
	dc.b	"donc pas d'adresse pour envoyer le pognon !!!",13,11
	dc.b	'juste mon e-mail : sbriais@free.fr',13,11
	dc.b	13,11
	dc.b	'Seb/The Removers.',13,11
	dc.b	13,11
	dc.b	'Press a key ...',0
	even
	
key:
	dc.b	27,'E'
	dc.b	'Please wait ...',13,11,0
	even
	
flag_it:
	dc.w	0
	
it_ok:
	dc.b	13,11,"L'it a eu lieu",13,11,0
	even
	
it_fail:
	dc.b	13,11,"L'it n'a pas eu lieu",13,11,0
	even
	
mon_son:
debut_son:
	incbin	'pognon.spl'
fin_son: